Index: chan_sip.c
===================================================================
--- chan_sip.c	(revision 53125)
+++ chan_sip.c	(working copy)
@@ -11745,6 +11745,10 @@
 
 		if (!ast_test_flag(req, SIP_PKT_IGNORE) && p->owner) {
 			if (!reinvite) {
+				if (p->rtp) {
+	                        	ast_rtp_setdtmf(p->rtp, ast_test_flag(&p->flags[0], SIP_DTMF) == SIP_DTMF_RFC2833);
+	                        	ast_rtp_setdtmfcompensate(p->rtp, ast_test_flag(&p->flags[1], SIP_PAGE2_RFC2833_COMPENSATE));
+				}
 				ast_queue_control(p->owner, AST_CONTROL_ANSWER);
 			} else {	/* RE-invite */
 				ast_queue_frame(p->owner, &ast_null_frame);
@@ -16844,6 +16848,8 @@
 {
 	struct sip_pvt *p;
 	char *mode;
+	int capability, x;
+	
 	if (data)
 		mode = (char *)data;
 	else {
@@ -16865,14 +16871,29 @@
 	if (!strcasecmp(mode,"info")) {
 		ast_clear_flag(&p->flags[0], SIP_DTMF);
 		ast_set_flag(&p->flags[0], SIP_DTMF_INFO);
+		capability = p->jointnoncodeccapability;
 	} else if (!strcasecmp(mode,"rfc2833")) {
 		ast_clear_flag(&p->flags[0], SIP_DTMF);
 		ast_set_flag(&p->flags[0], SIP_DTMF_RFC2833);
+		capability = AST_RTP_DTMF;
 	} else if (!strcasecmp(mode,"inband")) { 
 		ast_clear_flag(&p->flags[0], SIP_DTMF);
 		ast_set_flag(&p->flags[0], SIP_DTMF_INBAND);
+		capability = 0;
 	} else
 		ast_log(LOG_WARNING, "I don't know about this dtmf mode: %s\n",mode);
+
+	/* Setting jointnoncodeccapability to properly generate SDP later */
+	for (x = 1; x <= AST_RTP_MAX; x <<= 1) {
+		if ( x & capability )
+			p->jointnoncodeccapability |= x;
+		else
+			p->jointnoncodeccapability &= ~(x);
+	}
+	if (p->rtp) {
+		ast_rtp_setdtmf(p->rtp, ast_test_flag(&p->flags[0], SIP_DTMF) == SIP_DTMF_RFC2833);
+		ast_rtp_setdtmfcompensate(p->rtp, ast_test_flag(&p->flags[1], SIP_PAGE2_RFC2833_COMPENSATE));
+	}
 	if (ast_test_flag(&p->flags[0], SIP_DTMF) == SIP_DTMF_INBAND) {
 		if (!p->vad) {
 			p->vad = ast_dsp_new();
